"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var selectors_1 = require("./selectors");
var reducer_1 = require("./reducer");
var defaultConfigs_1 = require("./defaultConfigs");
var sagas_1 = require("./sagas");
var actions_1 = require("./actions");
exports.createActionCreators = actions_1.createActionCreators;
exports.SET = actions_1.SET;
exports.REMOVE = actions_1.REMOVE;
exports.EXPIRED = actions_1.EXPIRED;
var utils_1 = require("./utils");
exports.isTokenExpired = utils_1.isTokenExpired;
exports.createJWT = function (configs) {
    var mergedConfigs = __assign({}, defaultConfigs_1.defaultConfigs, configs);
    return {
        reducer: reducer_1.createReducer(mergedConfigs),
        saga: sagas_1.createRootSaga(mergedConfigs),
        createSelectors: selectors_1.createSelectors(mergedConfigs),
    };
};
exports.default = exports.createJWT;
