"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var actions_1 = require("./actions");
var effects_1 = require("redux-saga/effects");
var utils_1 = require("./utils");
function timer(id, ms) {
    var timeout;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, effects_1.race({
                    timeout: effects_1.delay(ms),
                    cancel: effects_1.call(takeRemove, id),
                })];
            case 1:
                timeout = (_a.sent()).timeout;
                if (!timeout) return [3, 3];
                return [4, effects_1.put(actions_1.createActionCreators(id).expired())];
            case 2:
                _a.sent();
                _a.label = 3;
            case 3: return [2];
        }
    });
}
exports.timer = timer;
function takeRemove(id) {
    var action;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!true) return [3, 2];
                return [4, effects_1.take(actions_1.REMOVE)];
            case 1:
                action = _a.sent();
                if (action.payload.id === id) {
                    return [2, true];
                }
                return [3, 0];
            case 2: return [2];
        }
    });
}
exports.takeRemove = takeRemove;
exports.syncToken = function (configs) { return function () {
    var tokens;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, effects_1.select(configs.stateSelector)];
            case 1:
                tokens = _a.sent();
                configs.setTokens(tokens);
                return [2];
        }
    });
}; };
exports.setTokenHandler = function (configs) { return function (action) {
    var _a, id, expiresIn;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = action.payload, id = _a.id, expiresIn = _a.token.expiresIn;
                return [4, effects_1.all([
                        effects_1.spawn(timer, id, expiresIn),
                        exports.syncToken(configs)(),
                    ])];
            case 1:
                _b.sent();
                return [2];
        }
    });
}; };
exports.checkExpiredWhenInitialize = function (configs) { return function () {
    var tokens, expiredTokenIds;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, effects_1.select(configs.stateSelector)];
            case 1:
                tokens = _a.sent();
                expiredTokenIds = Object.keys(tokens).filter(function (id) { return utils_1.isTokenExpired(tokens[id]); });
                if (!expiredTokenIds.length) {
                    return [2];
                }
                return [4, effects_1.all(expiredTokenIds.map(function (id) { return effects_1.put(actions_1.createActionCreators(id).expired()); }))];
            case 2:
                _a.sent();
                return [2];
        }
    });
}; };
exports.createRootSaga = function (configs) {
    return function rootSaga() {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, effects_1.all([
                        exports.checkExpiredWhenInitialize(configs)(),
                        effects_1.takeEvery(actions_1.SET, exports.setTokenHandler(configs)),
                        effects_1.takeEvery(actions_1.REMOVE, exports.syncToken(configs)),
                    ])];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    };
};
exports.default = exports.createRootSaga;
